var webpack = require('webpack');
var path = require('path');
var BUILD_DIR = path.resolve(__dirname, 'lib');
var APP_DIR = path.resolve(__dirname, 'src');
var ProgressBarPlugin = require('progress-bar-webpack-plugin');
var fs = require('fs');

var nodeModules = {};
fs.readdirSync('node_modules')
    .filter(function(x) {
        return ['.bin'].indexOf(x) === -1;
    })
    .forEach(function(mod) {
        nodeModules[mod] = 'commonjs ' + mod;
    });


var config = {
  context:APP_DIR,
  entry: './index.js',
  output: {
    path: BUILD_DIR,
    filename: 'index.js'
  },
  devtool: 'source-map',
  externals:nodeModules,
  module : {
    loaders : [
      {
        test : /\.js?/,
        include : APP_DIR,
        loader : 'babel'
      },
       {test: /\.css$/, loaders: ['style', 'css']}
    ]
  },
  plugins:[
    new ProgressBarPlugin()
  ]
};

module.exports = config;
